using Indotalent.Infrastructure.Database;
using MediatR;
using Microsoft.EntityFrameworkCore;

namespace Indotalent.Features.Purchase.Bill.Cqrs;

public record DeleteBillByIdCommand(string Id) : IRequest<bool>;

public class DeleteBillByIdHandler : IRequestHandler<DeleteBillByIdCommand, bool>
{
    private readonly AppDbContext _context;
    public DeleteBillByIdHandler(AppDbContext context) => _context = context;

    public async Task<bool> Handle(DeleteBillByIdCommand request, CancellationToken cancellationToken)
    {
        var entity = await _context.Bill
            .FirstOrDefaultAsync(x => x.Id == request.Id, cancellationToken);

        if (entity == null) return false;

        _context.Bill.Remove(entity);
        await _context.SaveChangesAsync(cancellationToken);
        return true;
    }
}